﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using NAudio.Wave;

namespace dcf77_send {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
        }

        //https://www.youtube.com/watch?v=Tumpkl-xJuA
        dcf77_output dcf77;
        private void button1_Click(object sender, EventArgs e) {
            dcf77 = new dcf77_output();
            dcf77.start(dateTimePicker1.Value);

            button2.Enabled = true;
            button1.Enabled = false;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e) {
            if (checkBox1.Checked) {
                timer1.Enabled = true;
                dateTimePicker1.Value = DateTime.Now;
                dateTimePicker1.Enabled = false;
                numericUpDown1.Enabled = true;
                label1.Enabled = true;
                label2.Enabled = true;
            } else {
                timer1.Enabled = false;
                dateTimePicker1.Enabled = true;
                numericUpDown1.Enabled = false;
                label1.Enabled = false;
                label2.Enabled = false;
            }
        }

        private void Form1_Load(object sender, EventArgs e) {
            numericUpDown1.Value = Properties.Settings.Default.time_offset_min;
            checkBox1.Checked = Properties.Settings.Default.systemtime_checkbox;
            dateTimePicker1.Value = (Properties.Settings.Default.time>new DateTime(1000,1,1)) ? Properties.Settings.Default.time : DateTime.Now;

            button2.Enabled = false;
        }

        private void timer1_Tick(object sender, EventArgs e) {
            dateTimePicker1.Value = DateTime.Now + new TimeSpan(0, (int)numericUpDown1.Value, 0);
        }

        private void button2_Click(object sender, EventArgs e) {
            dcf77.stop();

            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e) {
            if(dcf77!=null) dcf77.stop();

            Properties.Settings.Default.time_offset_min = (int)numericUpDown1.Value;
            Properties.Settings.Default.systemtime_checkbox = checkBox1.Checked;
            Properties.Settings.Default.time = dateTimePicker1.Value;
            Properties.Settings.Default.Save();
        }

    }
}
